defmodule Division do
  def division_cycle_length(0, _, _), do: 0

  def division_cycle_length(a, b, c) when a > b do 
    if Map.has_key?(c, a) do
      count_cycle(c, a)
    else
      q = div(a, b)
      division_cycle_length(a-q*b, b, Map.put(c, a, a-q*b))
    end
  end

  def division_cycle_length(a, b, c) when a < b do
    if Map.has_key?(c, a) do
      count_cycle(c, a)
    else
      k = a
      a = 10*a
      q = div(a, b)
      division_cycle_length(a-q*b, b, Map.put(c, k, a-q*b))
    end
  end

  defp count_cycle(map, start), do: count_cycle(map, Map.get(map, start), 1, start)
  defp count_cycle(_, fin, count, fin), do: count
  defp count_cycle(map, current, count, fin), do: count_cycle(map, Map.get(map, current), count + 1, fin)
end

{n, _} = 2..1000
  |> Stream.map(fn i ->
    {i, Division.division_cycle_length(1, i, %{})}
  end)
  |> Enum.max_by(&elem(&1, 1))

IO.puts(n)
